#include <sys/types.h>
#include <stdio.h>
#include <stdlib.h>
#undef _POSIX_SOURCE
#include <sys/capability.h>

int main(void) {
    cap_flag_value_t value;
    int i, j;
    cap_t data;

    data = cap_get_proc();
    printf("%-20s %s %s %s %-20s %s %s %s\n", "", "EFF", "PRM", "INH",
                                              "", "EFF", "PRM", "INH");
    for(i = 0; i < 16; ++i) {
        j = i + 16;

        printf("%-20s ", _cap_names[i]);
        cap_get_flag(data, i, CAP_EFFECTIVE, &value);
        printf(" %s  ", (value == CAP_SET) ? "X" : ".");
        cap_get_flag(data, i, CAP_PERMITTED, &value);
        printf(" %s  ", (value == CAP_SET) ? "X" : ".");
        cap_get_flag(data, i, CAP_INHERITABLE, &value);
        printf(" %s  ", (value == CAP_SET) ? "X" : ".");

        printf("%-20s ", _cap_names[j]);
        cap_get_flag(data, j, CAP_EFFECTIVE, &value);
        printf(" %s  ", (value == CAP_SET) ? "X" : ".");
        cap_get_flag(data, j, CAP_PERMITTED, &value);
        printf(" %s  ", (value == CAP_SET) ? "X" : ".");
        cap_get_flag(data, j, CAP_INHERITABLE, &value);
        printf(" %s", (value == CAP_SET) ? "X" : ".");

        printf("\n");
    }

    cap_free(data);
    return EXIT_SUCCESS;
}

//=============================================================================
